from dataclasses import dataclass

class DataSourceList(list):
    """Representation of the list of `DataSource` objects.

    The list inherits directly from Python `list`. The list does not
    communicate with the backend and thus, represent a snapshot at the
    moment it is created.
    """
    @dataclass(init=False)
    class ListItem:
        uid: str
        name: str = ...
        datatype: str = ...
        creation_date: str = ...
        status: str = ...
        connector_uid: str = ...
        def __init__(self, **_) -> None: ...
